---
title: WebGLRenderingContext.getUniform()
slug: Web/API/WebGLRenderingContext/getUniform
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.getUniform()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> returns the value of a uniform variable at a given location.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">any <var>gl</var>.getUniform(<var>program</var>, <var>location</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>program</dt>
 <dd>A {{domxref("WebGLProgram")}} containing the uniform attribute.</dd>
 <dt>location</dt>
 <dd>A {{domxref("WebGLUniformLocation")}} object containing the location of the uniform attribute to get.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The returned type depends on the uniform type:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Uniform type</th>
   <th scope="col">Returned type</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <th colspan="2">WebGL 1 only</th>
  </tr>
  <tr>
   <td><code>boolean</code></td>
   <td>{{domxref("GLBoolean")}}</td>
  </tr>
  <tr>
   <td><code>int</code></td>
   <td>{{domxref("GLint")}}</td>
  </tr>
  <tr>
   <td><code>float</code></td>
   <td>{{domxref("GLfloat")}}</td>
  </tr>
  <tr>
   <td><code>vec2</code></td>
   <td>{{jsxref("Float32Array")}} (with 2 elements)</td>
  </tr>
  <tr>
   <td><code>ivec2</code></td>
   <td>{{jsxref("Int32Array")}} (with 2 elements)</td>
  </tr>
  <tr>
   <td><code>bvec2</code></td>
   <td>{{jsxref("Array")}} of {{domxref("GLBoolean")}} (with 2 elements)</td>
  </tr>
  <tr>
   <td><code>vec3</code></td>
   <td>{{jsxref("Float32Array")}} (with 3 elements)</td>
  </tr>
  <tr>
   <td><code>ivec3</code></td>
   <td>{{jsxref("Int32Array")}} (with 3 elements)</td>
  </tr>
  <tr>
   <td><code>bvec3</code></td>
   <td>{{jsxref("Array")}} of {{domxref("GLBoolean")}} (with 3 elements)</td>
  </tr>
  <tr>
   <td><code>vec4</code></td>
   <td>{{jsxref("Float32Array")}} (with 4 elements)</td>
  </tr>
  <tr>
   <td><code>ivec4</code></td>
   <td>{{jsxref("Int32Array")}} (with 4 elements)</td>
  </tr>
  <tr>
   <td><code>bvec4</code></td>
   <td>{{jsxref("Array")}} of {{domxref("GLBoolean")}} (with 4 elements)</td>
  </tr>
  <tr>
   <td><code>mat2</code></td>
   <td>{{jsxref("Float32Array")}} (with 4 elements)</td>
  </tr>
  <tr>
   <td><code>mat3</code></td>
   <td>{{jsxref("Float32Array")}} (with 9 elements)</td>
  </tr>
  <tr>
   <td><code>mat4</code></td>
   <td>{{jsxref("Float32Array")}} (with 16 elements)</td>
  </tr>
  <tr>
   <td><code>sampler2D</code></td>
   <td>{{domxref("GLint")}}</td>
  </tr>
  <tr>
   <td><code>samplerCube</code></td>
   <td>{{domxref("GLint")}}</td>
  </tr>
  <tr>
   <th colspan="2">Additionally available in WebGL 2</th>
  </tr>
  <tr>
   <td><code>uint</code></td>
   <td>{{domxref("GLuint")}}</td>
  </tr>
  <tr>
   <td><code>uvec2</code></td>
   <td>{{jsxref("Uint32Array")}} (with 2 elements)</td>
  </tr>
  <tr>
   <td><code>uvec3</code></td>
   <td>{{jsxref("Uint32Array")}} (with 3 elements)</td>
  </tr>
  <tr>
   <td><code>uvec4</code></td>
   <td>{{jsxref("Uint32Array")}} (with 4 elements)</td>
  </tr>
  <tr>
   <td><code>mat2x3</code></td>
   <td>{{jsxref("Float32Array")}} (with 6 elements)</td>
  </tr>
  <tr>
   <td><code>mat2x4</code></td>
   <td>{{jsxref("Float32Array")}} (with 8 elements)</td>
  </tr>
  <tr>
   <td><code>mat3x2</code></td>
   <td>{{jsxref("Float32Array")}} (with 6 elements)</td>
  </tr>
  <tr>
   <td><code>mat3x4</code></td>
   <td>{{jsxref("Float32Array")}} (with 12 elements)</td>
  </tr>
  <tr>
   <td><code>mat4x2</code></td>
   <td>{{jsxref("Float32Array")}} (with 8 elements)</td>
  </tr>
  <tr>
   <td><code>mat4x3</code></td>
   <td>{{jsxref("Float32Array")}} (with 12 elements)</td>
  </tr>
  <tr>
   <td>any sampler type</td>
   <td>{{domxref("GLint")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var loc = gl.getUniformLocation(program, 'u_foobar');
gl.getUniform(program, loc);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.10", "getUniform")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glGetUniform.xml", "glGetUniform")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 2 API.</td>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.8", "getUniform")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Updated definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glGetUniform.xhtml", "glGetUniform")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 3 API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.getUniform")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLUniformLocation")}}</li>
 <li>{{domxref("WebGLRenderingContext.getActiveUniform()")}}</li>
</ul>
